; copyright HR
; special functions to provide for application code access to FLASH
; can be expanded with own functions and place a rjmp vector at end of this file

getappversion:
; return current application version if supported, otherwise returns 0xFFFFFFFF
.if UseVersioning
		ldi		zl, byte1(AppVerAddr)
		ldi		zh, byte2(AppVerAddr)
.if XMega
		ldi		r25, byte3(AppVerAddr)
		xout	RAMPZ, r25
.endif
		lpm		r22, Z+			; little endian
		lpm		r23, Z+
		lpm		r24, Z+
		lpm		r25, Z
.else
		ser		r25
		ser		r24
		ser		r23
		ser		r22		
.endif
		ret

getbootmsg:
; return address and size of BootMsg, can be used in application to read out BootMsg and follow datas if readaccess per LPM is not locked
		ldi		r22, byte1(BootMsg * 2)
		ldi		r23, byte2(BootMsg * 2)
		ldi		r24, byte3(BootMsg * 2)
		ldi		r25, (BootInfo - BootMsg) * 2
xret:	ret


; rjmp vectors for support from application code
; can be expanded with own vectors to own code, look into AVRootloader.h how to call
; please don't reorder this jump table, but you can expand it to own code
.org (FLASHEND +1) -3
		rjmp	getappversion
		rjmp	getbootmsg
		rjmp	bootstart
